diff --git a/src/scim_anthy_setup.cpp b/src/scim_anthy_setup.cpp
index 26ee41e..d202d15 100644
--- a/src/scim_anthy_setup.cpp
+++ b/src/scim_anthy_setup.cpp
@@ -2171,8 +2475,13 @@ on_key_list_view_key_press (GtkWidget *widget, GdkEventKey *event,
     GtkTreeView *treeview = GTK_TREE_VIEW (widget);
 
     switch (event->keyval) {
+#if GTK_CHECK_VERSION(3, 0, 0)
+    case GDK_KEY_Return:
+    case GDK_KEY_KP_Enter:
+#else
     case GDK_Return:
     case GDK_KP_Enter:
+#endif
         key_list_view_popup_key_selection (treeview);
         break;
     }
diff --git a/src/scim_anthy_setup_kana.cpp b/src/scim_anthy_setup_kana.cpp
index 0b71746..a0f8a13 100644
--- a/src/scim_anthy_setup_kana.cpp
+++ b/src/scim_anthy_setup_kana.cpp
@@ -65,15 +65,15 @@ static GtkWidget *create_kana_window                 (GtkWindow            *pare
 static GtkWidget *create_nicola_window               (GtkWindow            *parent);
 
 static void     setup_kana_page                      (void);
-static void     setup_kana_layout_menu               (GtkOptionMenu        *omenu);
-static void     setup_nicola_layout_menu             (GtkOptionMenu        *omenu);
+static void     setup_kana_layout_menu               (GtkWidget *omenu);
+static void     setup_nicola_layout_menu             (GtkWidget *omenu);
 static void     setup_kana_window_value              (ScimAnthyTableEditor *editor);
 static void     setup_nicola_window_value            (ScimAnthyTableEditor *editor);
 
 static bool     load_kana_layout                     (void);
 static bool     load_nicola_layout                   (void);
 
-static void     on_kana_layout_menu_changed          (GtkOptionMenu        *omenu,
+static void     on_kana_layout_menu_changed          (GtkWidget *omenu,
                                                       gpointer              user_data);
 static void     on_kana_customize_button_clicked     (GtkWidget            *button,
                                                       gpointer              data);
@@ -85,7 +85,7 @@ static void     on_kana_table_editor_remove_entry    (ScimAnthyTableEditor *edit
                                                       gpointer              data);
 static void     on_kana_table_editor_removed_entry   (ScimAnthyTableEditor *editor,
                                                       gpointer              data);
-static void     on_nicola_layout_menu_changed        (GtkOptionMenu        *omenu,
+static void     on_nicola_layout_menu_changed        (GtkWidget *omenu,
                                                       gpointer              user_data);
 static void     on_nicola_customize_button_clicked   (GtkWidget            *button,
                                                       gpointer              data);
@@ -103,7 +103,11 @@ kana_page_create_ui (void)
 {
     GtkWidget *vbox, *hbox, *label;
 
+#if GTK_CHECK_VERSION(3, 0, 0)
+    vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
+#else
     vbox = gtk_vbox_new (FALSE, 0);
+#endif
     gtk_container_set_border_width (GTK_CONTAINER(vbox), 8);
     gtk_widget_show (vbox);
 
@@ -130,12 +134,20 @@ kana_page_create_ui (void)
     gtk_container_add (GTK_CONTAINER (alignment), label);
     gtk_widget_show (label);
 
+#if GTK_CHECK_VERSION(3, 0, 0)
+    hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
+#else
     hbox = gtk_hbox_new (FALSE, 0);
+#endif
     gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);
     gtk_table_attach_defaults (GTK_TABLE (table), hbox, 1, 4, 1, 2);
     gtk_widget_show(hbox);
 
+#if GTK_CHECK_VERSION(2, 4, 0)
+    GtkWidget *omenu = gtk_combo_box_text_new ();
+#else
     GtkWidget *omenu = gtk_option_menu_new ();
+#endif
     __widget_kana_layout_menu = omenu;
     g_signal_connect (G_OBJECT (omenu), "changed",
                       G_CALLBACK (on_kana_layout_menu_changed), NULL);
@@ -181,12 +193,20 @@ kana_page_create_ui (void)
     gtk_container_add (GTK_CONTAINER (alignment), label);
     gtk_widget_show (label);
 
+#if GTK_CHECK_VERSION(3, 0, 0)
+    hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
+#else
     hbox = gtk_hbox_new (FALSE, 0);
+#endif
     gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);
     gtk_table_attach_defaults (GTK_TABLE (table), hbox, 1, 4, 4, 5);
     gtk_widget_show(hbox);
 
+#if GTK_CHECK_VERSION(2, 4, 0)
+    omenu = gtk_combo_box_text_new ();
+#else
     omenu = gtk_option_menu_new ();
+#endif
     __widget_nicola_layout_menu = omenu;
     g_signal_connect (G_OBJECT (omenu), "changed",
                       G_CALLBACK (on_nicola_layout_menu_changed), NULL);
@@ -202,7 +222,11 @@ kana_page_create_ui (void)
     gtk_widget_show (button);
 
     /* thumb shift keys */
+#if GTK_CHECK_VERSION(3, 0, 0)
+    hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
+#else
     hbox = gtk_hbox_new (FALSE, 0);
+#endif
     gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
     gtk_widget_show (hbox);
 
@@ -210,7 +234,7 @@ kana_page_create_ui (void)
     GtkWidget *widget = create_entry (SCIM_ANTHY_CONFIG_LEFT_THUMB_SHIFT_KEY,
                                       GTK_TABLE (table), 5);
     set_left_padding (widget, 20);
-    gtk_entry_set_editable (GTK_ENTRY (widget), FALSE);
+    gtk_editable_set_editable (GTK_EDITABLE (widget), FALSE);
     widget = create_key_select_button (SCIM_ANTHY_CONFIG_LEFT_THUMB_SHIFT_KEY,
                                        GTK_TABLE (table), 5);
 
@@ -218,7 +242,7 @@ kana_page_create_ui (void)
     widget = create_entry (SCIM_ANTHY_CONFIG_RIGHT_THUMB_SHIFT_KEY,
                            GTK_TABLE (table), 6);
     set_left_padding (widget, 20);
-    gtk_entry_set_editable (GTK_ENTRY (widget), FALSE);
+    gtk_editable_set_editable (GTK_EDITABLE (widget), FALSE);
     widget = create_key_select_button (SCIM_ANTHY_CONFIG_RIGHT_THUMB_SHIFT_KEY,
                                        GTK_TABLE (table), 6);
 
@@ -279,27 +303,50 @@ create_kana_window (GtkWindow *parent)
                           _("Customize Kana Layout Table"));
 
     // option menu area
+#if GTK_CHECK_VERSION(3, 0, 0)
+    GtkWidget *hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
+#else
     GtkWidget *hbox = gtk_hbox_new (FALSE, 0);
+#endif
     gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gtk_box_pack_start
+		(GTK_BOX (gtk_dialog_get_content_area (GTK_DIALOG (dialog))),
+		 hbox, FALSE, FALSE, 0);
+    gtk_box_reorder_child 
+		(GTK_BOX (gtk_dialog_get_content_area (GTK_DIALOG (dialog))),
+		 hbox, 0);
+#else
     gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), hbox,
                         FALSE, FALSE, 0);
     gtk_box_reorder_child (GTK_BOX (GTK_DIALOG (dialog)->vbox), hbox, 0);
+#endif
     gtk_widget_show(hbox);
 
     GtkWidget *label = gtk_label_new_with_mnemonic (_("Layout _table:"));
     gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 2);
     gtk_widget_show (label);
 
+#if GTK_CHECK_VERSION(2, 4, 0)
+    GtkWidget *omenu = gtk_combo_box_text_new ();
+#else
     GtkWidget *omenu = gtk_option_menu_new ();
+#endif
     __widget_kana_layout_menu2 = omenu;
     g_object_add_weak_pointer (G_OBJECT (omenu),
                                (gpointer*) &__widget_kana_layout_menu2);
     gtk_box_pack_start (GTK_BOX (hbox), omenu, FALSE, FALSE, 2);
-    setup_kana_layout_menu (GTK_OPTION_MENU (omenu));
+    setup_kana_layout_menu (omenu);
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_set_active (
+		GTK_COMBO_BOX (omenu),
+		gtk_combo_box_get_active (GTK_COMBO_BOX (__widget_kana_layout_menu)));
+#else
     gtk_option_menu_set_history
         (GTK_OPTION_MENU (omenu),
          gtk_option_menu_get_history (
              GTK_OPTION_MENU (__widget_kana_layout_menu)));
+#endif
     gtk_widget_show (omenu);
 
     gtk_label_set_mnemonic_widget (GTK_LABEL(label), omenu);
@@ -351,27 +398,50 @@ create_nicola_window (GtkWindow *parent)
                           _("Customize Thumb Shift Layout Table"));
 
     // option menu area
+#if GTK_CHECK_VERSION(3, 0, 0)
+    GtkWidget *hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
+#else
     GtkWidget *hbox = gtk_hbox_new (FALSE, 0);
+#endif
     gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gtk_box_pack_start
+		(GTK_BOX (gtk_dialog_get_content_area (GTK_DIALOG (dialog))),
+		 hbox, FALSE, FALSE, 0);
+    gtk_box_reorder_child 
+		(GTK_BOX (gtk_dialog_get_content_area (GTK_DIALOG (dialog))),
+		 hbox, 0);
+#else
     gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), hbox,
                         FALSE, FALSE, 0);
     gtk_box_reorder_child (GTK_BOX (GTK_DIALOG (dialog)->vbox), hbox, 0);
+#endif
     gtk_widget_show(hbox);
 
     GtkWidget *label = gtk_label_new_with_mnemonic (_("Layout _table:"));
     gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 2);
     gtk_widget_show (label);
 
+#if GTK_CHECK_VERSION(2, 4, 0)
+    GtkWidget *omenu = gtk_combo_box_text_new ();
+#else
     GtkWidget *omenu = gtk_option_menu_new ();
+#endif
     __widget_nicola_layout_menu2 = omenu;
     g_object_add_weak_pointer (G_OBJECT (omenu),
                                (gpointer*) &__widget_nicola_layout_menu2);
     gtk_box_pack_start (GTK_BOX (hbox), omenu, FALSE, FALSE, 2);
-    setup_nicola_layout_menu (GTK_OPTION_MENU (omenu));
+    setup_nicola_layout_menu (omenu);
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_set_active (
+		GTK_COMBO_BOX (omenu),
+		gtk_combo_box_get_active (GTK_COMBO_BOX (__widget_nicola_layout_menu)));
+#else
     gtk_option_menu_set_history
         (GTK_OPTION_MENU (omenu),
          gtk_option_menu_get_history (
              GTK_OPTION_MENU (__widget_nicola_layout_menu)));
+#endif
     gtk_widget_show (omenu);
 
     gtk_label_set_mnemonic_widget (GTK_LABEL(label), omenu);
@@ -406,13 +476,48 @@ create_nicola_window (GtkWindow *parent)
 static void
 setup_kana_page (void)
 {
-    setup_kana_layout_menu (GTK_OPTION_MENU (__widget_kana_layout_menu));
-    setup_nicola_layout_menu (GTK_OPTION_MENU (__widget_nicola_layout_menu));
+    setup_kana_layout_menu (__widget_kana_layout_menu);
+    setup_nicola_layout_menu (__widget_nicola_layout_menu);
 }
 
 static void
-setup_kana_layout_menu (GtkOptionMenu *omenu)
+setup_kana_layout_menu (GtkWidget *omenu)
 {
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_text_append_text (GTK_COMBO_BOX_TEXT (omenu), _("User defined"));
+    gtk_combo_box_text_append_text (GTK_COMBO_BOX_TEXT (omenu), _("Default"));
+
+    gint active_index = KANA_LAYOUT_INDEX_DEFAULT;
+    bool check_list = false;
+    if (__config_kana_layout_file == __user_style_file.get_file_name ()) {
+        active_index = KANA_LAYOUT_INDEX_USER_DEFINED;
+    } else {
+        check_list = true;
+    }
+
+    StyleFiles::iterator it;
+    gint i;
+    for (i = 0, it = __style_list.begin ();
+         it != __style_list.end ();
+         i++, it++)
+    {
+        StyleLines section;
+        if (!it->get_entry_list (section, __kana_fund_table))
+            continue;
+
+		gtk_combo_box_text_append_text 
+			(GTK_COMBO_BOX_TEXT (omenu), _(it->get_title().c_str()));
+
+        if (check_list) {
+            if (it->get_file_name () == __config_kana_layout_file) {
+                active_index = i + 2; // 2: user-define + default
+                check_list = false;
+            }
+        }
+    }
+
+    gtk_combo_box_set_active (GTK_COMBO_BOX (omenu), active_index);
+#else
     GtkWidget *menu = gtk_menu_new ();
     gtk_option_menu_set_menu (GTK_OPTION_MENU (omenu),
                               menu);
@@ -475,11 +580,47 @@ setup_kana_layout_menu (GtkOptionMenu *omenu)
         G_OBJECT (omenu),
         (gpointer) (on_kana_layout_menu_changed),
         NULL);
+#endif
 }
 
 static void
-setup_nicola_layout_menu (GtkOptionMenu *omenu)
+setup_nicola_layout_menu (GtkWidget *omenu)
 {
+#if GTK_CHECK_VERSION(2, 4, 0)
+	gtk_combo_box_text_append_text (GTK_COMBO_BOX_TEXT (omenu), _("User defined"));
+	gtk_combo_box_text_append_text (GTK_COMBO_BOX_TEXT (omenu), _("Default"));
+
+    gint active_index = NICOLA_LAYOUT_INDEX_DEFAULT;
+    bool check_list = false;
+    if (__config_nicola_layout_file == __user_style_file.get_file_name ()) {
+        active_index = NICOLA_LAYOUT_INDEX_USER_DEFINED;
+    } else {
+        check_list = true;
+    }
+
+    StyleFiles::iterator it;
+    gint i;
+    for (i = 0, it = __style_list.begin ();
+         it != __style_list.end ();
+         i++, it++)
+    {
+        StyleLines section;
+        if (!it->get_entry_list (section, __nicola_fund_table))
+            continue;
+
+		gtk_combo_box_text_append_text (
+			GTK_COMBO_BOX_TEXT (omenu), _(it->get_title().c_str()));
+
+        if (check_list) {
+            if (it->get_file_name () == __config_nicola_layout_file) {
+                active_index = i + 2; // 2: user-define + default
+                check_list = false;
+            }
+        }
+    }
+
+    gtk_combo_box_set_active (GTK_COMBO_BOX (omenu), active_index);
+#else
     GtkWidget *menu = gtk_menu_new ();
     gtk_option_menu_set_menu (GTK_OPTION_MENU (omenu),
                               menu);
@@ -542,6 +683,7 @@ setup_nicola_layout_menu (GtkOptionMenu *omenu)
         G_OBJECT (omenu),
         (gpointer) (on_nicola_layout_menu_changed),
         NULL);
+#endif
 }
 
 static void
@@ -656,6 +798,10 @@ setup_default_nicola_table (void)
 static bool
 load_kana_layout (void)
 {
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gint idx = gtk_combo_box_get_active (GTK_COMBO_BOX (__widget_kana_layout_menu));
+    gint theme_idx = idx - 2; // user definad and default
+#else
     GtkOptionMenu *omenu = GTK_OPTION_MENU (__widget_kana_layout_menu);
     gint idx = gtk_option_menu_get_history (omenu);
     GtkWidget *menu = gtk_option_menu_get_menu (omenu);
@@ -667,6 +813,7 @@ load_kana_layout (void)
 
     gint theme_idx = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (menuitem),
                                                          INDEX_KEY));
+#endif
 
     // set new kana table
     if (idx == KANA_LAYOUT_INDEX_USER_DEFINED) {
@@ -716,6 +863,10 @@ load_kana_layout (void)
 static bool
 load_nicola_layout (void)
 {
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gint idx = gtk_combo_box_get_active (GTK_COMBO_BOX (__widget_nicola_layout_menu));
+    gint theme_idx = idx - 2; // user definad and default
+#else
     GtkOptionMenu *omenu = GTK_OPTION_MENU (__widget_nicola_layout_menu);
     gint idx = gtk_option_menu_get_history (omenu);
     GtkWidget *menu = gtk_option_menu_get_menu (omenu);
@@ -727,6 +878,7 @@ load_nicola_layout (void)
 
     gint theme_idx = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (menuitem),
                                                          INDEX_KEY));
+#endif
 
     // set new NICOLA table
     if (idx == NICOLA_LAYOUT_INDEX_USER_DEFINED) {
@@ -794,7 +946,7 @@ has_voiced_consonant (String str)
 }
 
 static void
-on_kana_layout_menu_changed (GtkOptionMenu *omenu, gpointer user_data)
+on_kana_layout_menu_changed (GtkWidget *omenu, gpointer user_data)
 {
     bool success;
 
@@ -803,9 +955,15 @@ on_kana_layout_menu_changed (GtkOptionMenu *omenu, gpointer user_data)
             G_OBJECT (__widget_kana_layout_menu),
             (gpointer) (on_kana_layout_menu_changed),
             NULL);
+#if GTK_CHECK_VERSION(2, 4, 0)
+        gtk_combo_box_set_active (
+            GTK_COMBO_BOX (__widget_kana_layout_menu),
+            gtk_combo_box_get_active (GTK_COMBO_BOX (omenu)));
+#else
         gtk_option_menu_set_history (
             GTK_OPTION_MENU (__widget_kana_layout_menu),
-            gtk_option_menu_get_history (omenu));
+            gtk_option_menu_get_history (GTK_OPTION_MENU (omenu)));
+#endif
         g_signal_handlers_unblock_by_func (
             G_OBJECT (__widget_kana_layout_menu),
             (gpointer) (on_kana_layout_menu_changed),
@@ -853,9 +1011,15 @@ static void
 on_kana_table_editor_added_entry (ScimAnthyTableEditor *editor, gpointer data)
 {
     // change menu item to "User defined"
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_set_active (
+        GTK_COMBO_BOX (__widget_kana_layout_menu2),
+        KANA_LAYOUT_INDEX_USER_DEFINED);
+#else
     gtk_option_menu_set_history (
         GTK_OPTION_MENU (__widget_kana_layout_menu2),
         KANA_LAYOUT_INDEX_USER_DEFINED);
+#endif
 
     __style_changed = true;
 }
@@ -874,15 +1038,21 @@ static void
 on_kana_table_editor_removed_entry (ScimAnthyTableEditor *editor, gpointer data)
 {
     // change menu item to "User deined"
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_set_active (
+        GTK_COMBO_BOX (__widget_kana_layout_menu2),
+        KANA_LAYOUT_INDEX_USER_DEFINED);
+#else
     gtk_option_menu_set_history (
         GTK_OPTION_MENU (__widget_kana_layout_menu2),
         KANA_LAYOUT_INDEX_USER_DEFINED);
+#endif
 
     __style_changed = true;
 }
 
 static void
-on_nicola_layout_menu_changed (GtkOptionMenu *omenu, gpointer user_data)
+on_nicola_layout_menu_changed (GtkWidget *omenu, gpointer user_data)
 {
     bool success;
 
@@ -891,9 +1061,15 @@ on_nicola_layout_menu_changed (GtkOptionMenu *omenu, gpointer user_data)
             G_OBJECT (__widget_nicola_layout_menu),
             (gpointer) (on_nicola_layout_menu_changed),
             NULL);
+#if GTK_CHECK_VERSION(2, 4, 0)
+        gtk_combo_box_set_active (
+            GTK_COMBO_BOX (__widget_nicola_layout_menu),
+            gtk_combo_box_get_active (GTK_COMBO_BOX (omenu)));
+#else
         gtk_option_menu_set_history (
             GTK_OPTION_MENU (__widget_nicola_layout_menu),
-            gtk_option_menu_get_history (omenu));
+            gtk_option_menu_get_history (GTK_OPTION_MENU (omenu)));
+#endif 
         g_signal_handlers_unblock_by_func (
             G_OBJECT (__widget_nicola_layout_menu),
             (gpointer) (on_nicola_layout_menu_changed),
@@ -937,9 +1113,15 @@ static void
 on_nicola_table_editor_added_entry (ScimAnthyTableEditor *editor, gpointer data)
 {
     // change menu item to "User defined"
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_set_active (
+        GTK_COMBO_BOX (__widget_nicola_layout_menu2),
+        NICOLA_LAYOUT_INDEX_USER_DEFINED);
+#else
     gtk_option_menu_set_history (
         GTK_OPTION_MENU (__widget_nicola_layout_menu2),
         NICOLA_LAYOUT_INDEX_USER_DEFINED);
+#endif
 
     __style_changed = true;
 }
@@ -958,9 +1140,15 @@ static void
 on_nicola_table_editor_removed_entry (ScimAnthyTableEditor *editor, gpointer data)
 {
     // change menu item to "User deined"
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_set_active (
+        GTK_COMBO_BOX (__widget_nicola_layout_menu2),
+        NICOLA_LAYOUT_INDEX_USER_DEFINED);
+#else
     gtk_option_menu_set_history (
         GTK_OPTION_MENU (__widget_nicola_layout_menu2),
         NICOLA_LAYOUT_INDEX_USER_DEFINED);
+#endif
 
     __style_changed = true;
 }
diff --git a/src/scim_anthy_setup_romaji.cpp b/src/scim_anthy_setup_romaji.cpp
index 9041736..d5a84a5 100644
--- a/src/scim_anthy_setup_romaji.cpp
+++ b/src/scim_anthy_setup_romaji.cpp
@@ -55,14 +55,14 @@ static String __config_romaji_theme_file = SCIM_ANTHY_CONFIG_ROMAJI_THEME_FILE_D
 static GtkWidget *create_romaji_window            (GtkWindow            *parent);
 
 static void     setup_romaji_page                 (void);
-static void     setup_romaji_theme_menu           (GtkOptionMenu        *omenu);
+static void     setup_romaji_theme_menu           (GtkWidget *omenu);
 static void     setup_romaji_window_value         (ScimAnthyTableEditor *editor);
 
 static bool     load_romaji_theme                 (void);
 
 static void     on_romaji_pseudo_ascii_mode_toggled(GtkToggleButton *togglebutton,
                                                     gpointer         user_data);
-static void     on_romaji_theme_menu_changed       (GtkOptionMenu        *omenu,
+static void     on_romaji_theme_menu_changed       (GtkWidget *omenu,
                                                     gpointer              user_data);
 static void     on_romaji_customize_button_clicked (GtkWidget            *button,
                                                     gpointer              data);
@@ -80,7 +80,11 @@ romaji_page_create_ui (void)
 {
     GtkWidget *vbox, *hbox, *table, *widget, *label;
 
+#if GTK_CHECK_VERSION(3, 0, 0)
+    vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
+#else
     vbox = gtk_vbox_new (FALSE, 0);
+#endif
     gtk_container_set_border_width (GTK_CONTAINER(vbox), 8);
     gtk_widget_show (vbox);
 
@@ -115,7 +119,11 @@ romaji_page_create_ui (void)
     on_romaji_pseudo_ascii_mode_toggled (GTK_TOGGLE_BUTTON (widget), NULL);
 
     /* romaji table */
+#if GTK_CHECK_VERSION(3, 0, 0)
+    hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
+#else
     hbox = gtk_hbox_new (FALSE, 0);
+#endif
     gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);
     gtk_table_attach (GTK_TABLE (table), hbox,
                       0, 4, 5, 6,
@@ -128,7 +136,11 @@ romaji_page_create_ui (void)
     gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 2);
     gtk_widget_show (label);
 
+#if GTK_CHECK_VERSION(2, 4, 0)
+    GtkWidget *omenu = gtk_combo_box_text_new ();
+#else
     GtkWidget *omenu = gtk_option_menu_new ();
+#endif
     __widget_romaji_theme_menu = omenu;
     g_signal_connect (G_OBJECT (omenu), "changed",
                       G_CALLBACK (on_romaji_theme_menu_changed), NULL);
@@ -188,27 +200,52 @@ create_romaji_window (GtkWindow *parent)
                           _("Customize Romaji Table"));
 
     // option menu area
+#if GTK_CHECK_VERSION(3, 0, 0)
+    GtkWidget *hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
+#else
     GtkWidget *hbox = gtk_hbox_new (FALSE, 0);
+#endif
+
     gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);
+
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gtk_box_pack_start
+		(GTK_BOX (gtk_dialog_get_content_area (GTK_DIALOG (dialog))),
+		 hbox, FALSE, FALSE, 0);
+    gtk_box_reorder_child 
+		(GTK_BOX (gtk_dialog_get_content_area (GTK_DIALOG (dialog))),
+		 hbox, 0);
+#else
     gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), hbox,
                         FALSE, FALSE, 0);
     gtk_box_reorder_child (GTK_BOX (GTK_DIALOG (dialog)->vbox), hbox, 0);
+#endif
+
     gtk_widget_show(hbox);
 
     GtkWidget *label = gtk_label_new_with_mnemonic (_("Romaji _table:"));
     gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 2);
     gtk_widget_show (label);
 
+#if GTK_CHECK_VERSION(2, 4, 0)
+    GtkWidget *omenu = gtk_combo_box_text_new ();
+#else
     GtkWidget *omenu = gtk_option_menu_new ();
+#endif
     __widget_romaji_theme_menu2 = omenu;
     g_object_add_weak_pointer (G_OBJECT (omenu),
                                (gpointer*) &__widget_romaji_theme_menu2);
     gtk_box_pack_start (GTK_BOX (hbox), omenu, FALSE, FALSE, 2);
-    setup_romaji_theme_menu (GTK_OPTION_MENU (omenu));
+    setup_romaji_theme_menu (omenu);
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_set_active (GTK_COMBO_BOX (omenu),
+         gtk_combo_box_get_active (GTK_COMBO_BOX (__widget_romaji_theme_menu)));
+#else
     gtk_option_menu_set_history
         (GTK_OPTION_MENU (omenu),
          gtk_option_menu_get_history (
              GTK_OPTION_MENU (__widget_romaji_theme_menu)));
+#endif
     gtk_widget_show (omenu);
 
     gtk_label_set_mnemonic_widget (GTK_LABEL(label), omenu);
@@ -243,12 +280,47 @@ create_romaji_window (GtkWindow *parent)
 static void
 setup_romaji_page (void)
 {
-    setup_romaji_theme_menu (GTK_OPTION_MENU (__widget_romaji_theme_menu));
+    setup_romaji_theme_menu (__widget_romaji_theme_menu);
 }
 
 static void
-setup_romaji_theme_menu (GtkOptionMenu *omenu)
+setup_romaji_theme_menu (GtkWidget *omenu)
 {
+#if GTK_CHECK_VERSION(2, 4, 0)
+	gtk_combo_box_text_append_text (GTK_COMBO_BOX_TEXT (omenu), _("User defined"));
+	gtk_combo_box_text_append_text (GTK_COMBO_BOX_TEXT (omenu), _("Default"));
+
+	gint active_index = ROMAJI_THEME_INDEX_DEFAULT;
+    bool check_list = false;
+    if (__config_romaji_theme_file == __user_style_file.get_file_name ()) {
+		active_index = ROMAJI_THEME_INDEX_USER_DEFINED;
+	} else {
+        check_list = true;
+	}
+
+    StyleFiles::iterator it;
+    unsigned int i;
+    for (i = 0, it = __style_list.begin ();
+         it != __style_list.end ();
+         i++, it++)
+    {
+        StyleLines section;
+        if (!it->get_entry_list (section, __romaji_fund_table))
+            continue;
+
+		gtk_combo_box_text_append_text 
+			(GTK_COMBO_BOX_TEXT (omenu), _(it->get_title().c_str()));
+
+        if (check_list) {
+            if (it->get_file_name () == __config_romaji_theme_file) {
+                active_index = i + 2; // 2: user-define + default
+                check_list = false;
+			}
+		}
+    }
+
+    gtk_combo_box_set_active (GTK_COMBO_BOX (omenu), active_index);
+#else
     GtkWidget *menu = gtk_menu_new ();
     gtk_option_menu_set_menu (GTK_OPTION_MENU (omenu),
                               menu);
@@ -311,6 +383,7 @@ setup_romaji_theme_menu (GtkOptionMenu *omenu)
         G_OBJECT (omenu),
         (gpointer) (on_romaji_theme_menu_changed),
         NULL);
+#endif
 }
 
 static void
@@ -370,6 +443,11 @@ setup_default_romaji_table (void)
 static bool
 load_romaji_theme (void)
 {
+#if GTK_CHECK_VERSION(2, 4, 0)
+    GtkWidget *omenu = __widget_romaji_theme_menu;
+    gint idx = gtk_combo_box_get_active (GTK_COMBO_BOX (omenu));
+	gint theme_idx = idx - 2; // 2: user-defined + default
+#else
     GtkOptionMenu *omenu = GTK_OPTION_MENU (__widget_romaji_theme_menu);
     gint idx = gtk_option_menu_get_history (omenu);
     GtkWidget *menu = gtk_option_menu_get_menu (omenu);
@@ -381,6 +459,7 @@ load_romaji_theme (void)
 
     gint theme_idx = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (menuitem),
                                                          INDEX_KEY));
+#endif
 
     // set new romaji table
     if (idx == ROMAJI_THEME_INDEX_USER_DEFINED) {
@@ -440,7 +519,7 @@ on_romaji_pseudo_ascii_mode_toggled (GtkToggleButton *togglebutton,
 }
 
 static void
-on_romaji_theme_menu_changed (GtkOptionMenu *omenu, gpointer user_data)
+on_romaji_theme_menu_changed (GtkWidget *omenu, gpointer user_data)
 {
     bool success;
 
@@ -449,9 +528,15 @@ on_romaji_theme_menu_changed (GtkOptionMenu *omenu, gpointer user_data)
             G_OBJECT (__widget_romaji_theme_menu),
             (gpointer) (on_romaji_theme_menu_changed),
             NULL);
+#if GTK_CHECK_VERSION(2, 4, 0)
+        gtk_combo_box_set_active (
+            GTK_COMBO_BOX (__widget_romaji_theme_menu),
+            gtk_combo_box_get_active (GTK_COMBO_BOX (omenu)));
+#else
         gtk_option_menu_set_history (
             GTK_OPTION_MENU (__widget_romaji_theme_menu),
-            gtk_option_menu_get_history (omenu));
+            gtk_option_menu_get_history (GTK_OPTION_MENU (omenu)));
+#endif
         g_signal_handlers_unblock_by_func (
             G_OBJECT (__widget_romaji_theme_menu),
             (gpointer) (on_romaji_theme_menu_changed),
@@ -495,9 +580,15 @@ static void
 on_table_editor_added_entry (ScimAnthyTableEditor *editor, gpointer data)
 {
     // change menu item to "User defined"
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_set_active (
+        GTK_COMBO_BOX (__widget_romaji_theme_menu2),
+        ROMAJI_THEME_INDEX_USER_DEFINED);
+#else
     gtk_option_menu_set_history (
         GTK_OPTION_MENU (__widget_romaji_theme_menu2),
         ROMAJI_THEME_INDEX_USER_DEFINED);
+#endif
 
     __style_changed = true;
 }
@@ -518,9 +609,15 @@ static void
 on_table_editor_removed_entry (ScimAnthyTableEditor *editor, gpointer data)
 {
     // change menu item to "User deined"
+#if GTK_CHECK_VERSION(2, 4, 0)
+    gtk_combo_box_set_active (
+        GTK_COMBO_BOX (__widget_romaji_theme_menu2),
+        ROMAJI_THEME_INDEX_USER_DEFINED);
+#else
     gtk_option_menu_set_history (
         GTK_OPTION_MENU (__widget_romaji_theme_menu2),
         ROMAJI_THEME_INDEX_USER_DEFINED);
+#endif
 
     __style_changed = true;
 }
diff --git a/src/scim_anthy_table_editor.cpp b/src/scim_anthy_table_editor.cpp
index fb3c040..7b25415 100644
--- a/src/scim_anthy_table_editor.cpp
+++ b/src/scim_anthy_table_editor.cpp
@@ -131,10 +131,20 @@ scim_anthy_table_editor_init (ScimAnthyTableEditor *editor)
     gtk_window_set_position (GTK_WINDOW (editor),
                              GTK_WIN_POS_CENTER_ON_PARENT);
 
+#if GTK_CHECK_VERSION(3, 0, 0)
+    GtkWidget *hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
+#else
     GtkWidget *hbox = gtk_hbox_new (FALSE, 0);
+#endif
     gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gtk_box_pack_start
+		(GTK_BOX (gtk_dialog_get_content_area (GTK_DIALOG (editor))),
+		 hbox, TRUE, TRUE, 0);
+#else
     gtk_box_pack_start (GTK_BOX (GTK_DIALOG (editor)->vbox), hbox,
                         TRUE, TRUE, 0);
+#endif
     gtk_widget_show (hbox);
 
     GtkWidget *label = gtk_label_new_with_mnemonic (_("Table _entries:"));
@@ -142,10 +152,20 @@ scim_anthy_table_editor_init (ScimAnthyTableEditor *editor)
     gtk_widget_show (label);
 
     // edit area
+#if GTK_CHECK_VERSION(3, 0, 0)
+    hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
+#else
     hbox = gtk_hbox_new (FALSE, 0);
+#endif
     gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gtk_box_pack_start
+		(GTK_BOX (gtk_dialog_get_content_area (GTK_DIALOG (editor))),
+		 hbox, TRUE, TRUE, 0);
+#else
     gtk_box_pack_start (GTK_BOX (GTK_DIALOG (editor)->vbox), hbox,
                         TRUE, TRUE, 0);
+#endif
     gtk_widget_show (hbox);
 
     // tree view area
@@ -174,7 +194,11 @@ scim_anthy_table_editor_init (ScimAnthyTableEditor *editor)
     gtk_tree_view_set_headers_clickable (GTK_TREE_VIEW (treeview), TRUE);
 
     // button area
+#if GTK_CHECK_VERSION(3, 0, 0)
+    GtkWidget *vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
+#else
     GtkWidget *vbox = gtk_vbox_new (FALSE, 0);
+#endif
     editor->button_area = vbox;
     gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, FALSE, 5);
     gtk_widget_show (vbox);
